VERSION 5.00
Begin VB.UserControl HoverButton 
   Appearance      =   0  'Flat
   BackColor       =   &H00FFFFFF&
   ClientHeight    =   555
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3690
   ScaleHeight     =   555
   ScaleWidth      =   3690
   ToolboxBitmap   =   "lightbutton.ctx":0000
   Begin VB.Timer Timer 
      Interval        =   100
      Left            =   3120
      Top             =   0
   End
   Begin VB.Line Line4 
      BorderWidth     =   2
      X1              =   120
      X2              =   390
      Y1              =   360
      Y2              =   360
   End
   Begin VB.Line Line3 
      BorderWidth     =   2
      X1              =   120
      X2              =   390
      Y1              =   210
      Y2              =   210
   End
   Begin VB.Line Line2 
      BorderWidth     =   2
      X1              =   120
      X2              =   390
      Y1              =   120
      Y2              =   120
   End
   Begin VB.Line Line1 
      BorderWidth     =   2
      X1              =   120
      X2              =   390
      Y1              =   30
      Y2              =   30
   End
   Begin VB.Label lblCaption 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      BackStyle       =   0  'Transparent
      Caption         =   "Label1"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   20.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000008&
      Height          =   480
      Left            =   720
      TabIndex        =   0
      Top             =   0
      Width           =   1335
   End
End
Attribute VB_Name = "HoverButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Enum TheButtonMode
    [Text Only Mode] = 0
    [Image Only Mode] = 1
End Enum

Public Enum TheBorderStyle
    None = 0
    Inset = 1
    Raised = 2
End Enum

Public Event Click()
Public Event DblClick()
Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Public Event KeyPress(KeyAscii As Integer)
Public Event KeyUp(KeyCode As Integer, Shift As Integer)
Public Event StatusChanged(NewStatus As Integer)
Attribute StatusChanged.VB_Description = "Triggered if the control's status changes from selected to unselected, or vice versa."
Attribute StatusChanged.VB_MemberFlags = "200"

Private TheButtonLighted As Boolean
Private TheFont As StdFont
Private TheFontSelColor As OLE_COLOR
Private TheFontOldColor As OLE_COLOR 'store the original color
Private TheMode As TheButtonMode
Private TheBackColor As OLE_COLOR
Private TheSelColor As OLE_COLOR
Private ThePicture As New StdPicture
Private TheSelPicture As New StdPicture
Private TheCursorPos As POINTAPI
Private TheBorder As TheBorderStyle
Private TheBorderHighLight As OLE_COLOR
Private TheBorderShadow As OLE_COLOR
'Event Declarations:
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=lblCaption,lblCaption,-1,MouseDown
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=lblCaption,lblCaption,-1,MouseMove
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=lblCaption,lblCaption,-1,MouseUp
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."

Private Sub Timer_Timer()
    ' the timer is set at 100 and will fire approx 10 per second
   
    Dim CursorStatus As Long
    Dim CurrenthWnd As Long
    
    ' Disable the timer temporarily.
    Timer.Enabled = False
    
    ' Using two Windows API functions, determine the
    ' handle of the window that the cursor is
    ' currently positioned on.
    CursorStatus = GetCursorPos&(TheCursorPos)
    CurrenthWnd = WindowFromPoint(TheCursorPos.X, TheCursorPos.Y)
    
    If TheButtonLighted = False Then
        ' If the control is not currently "lighted",
        ' and it matches the handle of the window that
        ' the cursor is on, light it up (if
        ' ButtonMode = Text Only Mode) or switch its
        ' background image to the one that indicates
        ' that the button is selected.
        If CurrenthWnd = UserControl.hWnd Then
            TheButtonLighted = True
            If TheMode = [Text Only Mode] Then
                UserControl.BackColor = TheSelColor
                lblCaption.ForeColor = TheFontSelColor
            Else
                Set UserControl.Picture = TheSelPicture
            End If
            RaiseEvent StatusChanged(1)
        End If
    Else
        ' If the control is "lit", and it no longer
        ' matches the handle of the window that the
        ' cursor is on, un-light it (if
        ' ButtonMode = Text Only Mode) or switch
        ' its background image to the one that indicates
        ' that the button is not selected.
        If CurrenthWnd <> UserControl.hWnd Then
            TheButtonLighted = False
            If TheMode = [Text Only Mode] Then
                UserControl.BackColor = TheBackColor
                lblCaption.ForeColor = TheFontOldColor
            Else
                Set UserControl.Picture = ThePicture
            End If
            RaiseEvent StatusChanged(0)
        End If
    End If
    
    ' Re-enable the timer.
    Timer.Enabled = True

End Sub

Private Sub UserControl_Click()

    ' If UserControl's Click event is triggered,
    ' LightButton's Click event is in turn raised.
    RaiseEvent Click

End Sub

Private Sub UserControl_DblClick()

    ' If UserControl's Click event is triggered,
    ' LightButton's DblClick event is in turn raised.
    RaiseEvent DblClick

End Sub

Private Sub UserControl_Initialize()

    ' When the control initializes, the button is
    ' not "lighted".
    TheButtonLighted = False
    
    ' Since the control's status has just been
    ' initialized, the StatusChanged event should
    ' be raised.
    RaiseEvent StatusChanged(0)
    
    ' Since UserControl's BackColor property will
    ' be changed if the control is "selected", its
    ' initial value must be stored in a temporary
    ' variable.
    TheBackColor = UserControl.BackColor

End Sub

Private Sub UserControl_InitProperties()

    ' If the control's container is in design mode,
    ' disable the Timer, which causes the control to
    ' not function.
    Timer.Enabled = Ambient.UserMode
    
    ' Set the default values for some properties.
    
    ' The Caption property defaults to the name
    ' assigned to the control by its container.
    Caption = Ambient.DisplayName

    ' The SelColor property defaults to the color
    ' yellow.
    TheSelColor = &H80FFFF
    'default backcolor
    TheBackColor = vbButtonFace
    
    'default settings
    TheMode = [Text Only Mode]
    TheBorder = None
    TheBorderHighLight = vb3DHighlight
    TheBorderShadow = vb3DDKShadow
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)

    RaiseEvent KeyDown(KeyCode, Shift)

End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)

    RaiseEvent KeyPress(KeyAscii)

End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)

    RaiseEvent KeyUp(KeyCode, Shift)

End Sub

' the following Mouse events are mapped to the label's mouse events as well
' if the usercontrol events are commented out (which the 'wizard' wants) the mouse
' events will only fire if the mouse is on the label. you could have the label stretch
' to the size of the control...but this works just as well
Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

    RaiseEvent MouseDown(Button, Shift, X, Y)

End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

    RaiseEvent MouseMove(Button, Shift, X, Y)

End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

    RaiseEvent MouseUp(Button, Shift, X, Y)

End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    ' If the control's container is in design mode,
    ' disable the Timer, which causes the control to
    ' not function.
    Timer.Enabled = Ambient.UserMode
    
    ' Get properties from the property bag.
    BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    BorderStyle = PropBag.ReadProperty("BorderStyle", 0)
    ButtonMode = PropBag.ReadProperty("ButtonMode", TheMode)
    Caption = PropBag.ReadProperty("Caption", Ambient.DisplayName)
    Enabled = PropBag.ReadProperty("Enabled", True)
    ForeColor = PropBag.ReadProperty("ForeColor", &H80000008)
    SelBackColor = PropBag.ReadProperty("SelBackColor", &H80FFFF)
    SelFontColor = PropBag.ReadProperty("SelFontColor", vbBlack)
    BorderHighLight = PropBag.ReadProperty("BorderHighLight", vb3DHighlight)
    BorderShadow = PropBag.ReadProperty("BorderShadow", vb3DDKShadow)
    Set Font = PropBag.ReadProperty("Font", TheFont)
    Set Picture = PropBag.ReadProperty("Picture", Nothing)
    Set SelPicture = PropBag.ReadProperty("SelPicture", Nothing)
    
    
End Sub

Private Sub UserControl_Resize()

    ' Reposition the Label constituent control so it
    ' is centered within the UserControl.
    lblCaption.Top = (Height - lblCaption.Height) / 2
    lblCaption.Left = (Width - lblCaption.Width) / 2
    Call NewBorderStyle
    
End Sub

Public Property Get Caption() As String
Attribute Caption.VB_Description = "The text that is displayed on the control. Only used if the ButtonMode property is set to Text Only Mode (0)."
Attribute Caption.VB_ProcData.VB_Invoke_Property = ";Appearance"

    Caption = lblCaption.Caption

End Property

Public Property Let Caption(ByVal vNewValue As String)

    lblCaption.Caption = vNewValue
    UserControl.PropertyChanged "Caption"

End Property

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    ' Save properties to the property bag.
    PropBag.WriteProperty "BackColor", BackColor, &H8000000F
    PropBag.WriteProperty "BorderStyle", BorderStyle, 0
    PropBag.WriteProperty "ButtonMode", ButtonMode, TheMode
    PropBag.WriteProperty "Caption", Caption, Ambient.DisplayName
    PropBag.WriteProperty "Enabled", Enabled, True
    PropBag.WriteProperty "ForeColor", ForeColor, &H80000008
    PropBag.WriteProperty "SelBackColor", SelBackColor, &H80FFFF
    PropBag.WriteProperty "BorderHighLight", BorderHighLight, vb3DHighlight
    PropBag.WriteProperty "BorderShadow", BorderShadow, vb3DDKShadow
    PropBag.WriteProperty "Font", Font, TheFont
    PropBag.WriteProperty "Picture", Picture, Nothing
    PropBag.WriteProperty "SelPicture", SelPicture, Nothing
    PropBag.WriteProperty "SelFontColor", SelFontColor, vbBlack
End Sub

Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Specifies the control's background color. Only used if the ButtonMode property is set to Text Only Mode (0)."
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Appearance"

    BackColor = UserControl.BackColor

End Property

Public Property Let BackColor(ByVal newvalue As OLE_COLOR)

    UserControl.BackColor = newvalue
    UserControl.PropertyChanged "BackColor"
    
    TheBackColor = newvalue
    
End Property
Public Property Get BorderShadow() As OLE_COLOR
    BorderShadow = TheBorderShadow
    
End Property

Public Property Let BorderShadow(ByVal NewColor As OLE_COLOR)
    TheBorderShadow = NewColor
    UserControl.PropertyChanged "BorderShadow"
    Call NewBorderStyle

End Property

Public Property Get BorderHighLight() As OLE_COLOR
    BorderHighLight = TheBorderHighLight
    
End Property

Public Property Let BorderHighLight(ByVal NewColor As OLE_COLOR)
    TheBorderHighLight = NewColor
    UserControl.PropertyChanged "BorderHighLight"
    Call NewBorderStyle
End Property


Public Property Get BorderStyle() As TheBorderStyle
Attribute BorderStyle.VB_Description = "Specifies the type of border the control should have (0=None, 1=Fixed Single)."
Attribute BorderStyle.VB_ProcData.VB_Invoke_Property = ";Appearance"

    BorderStyle = TheBorder
    
End Property

Public Property Let BorderStyle(ByVal newvalue As TheBorderStyle)
    TheBorder = newvalue
    Call NewBorderStyle
    
End Property

Public Property Get ButtonMode() As TheButtonMode
Attribute ButtonMode.VB_Description = "Determines how the control will function. Text Only Mode (0) uses the background color to indicate the control's state, and ImageMode (1) uses images to indicate state."
Attribute ButtonMode.VB_ProcData.VB_Invoke_Property = ";Behavior"

    ButtonMode = TheMode
    
End Property

Public Property Let ButtonMode(ByVal newvalue As TheButtonMode)

    ' Don't let a new value be assigned to
    ' mmodButtonMode (ButtonMode's "holding" variable)
    ' unless it is valid.
    If newvalue = [Text Only Mode] Or newvalue = [Image Only Mode] Then
        TheMode = newvalue
        ' If ButtonMode is Text Only Mode (0), show
        ' the lblCaption object. If ButtonMode is
        ' Image Mode (1), hide the lblCaption object.
        If TheMode = [Text Only Mode] Then lblCaption.Visible = True
        If TheMode = [Image Only Mode] Then lblCaption.Visible = False
        UserControl.PropertyChanged "ButtonMode"
    Else
        ' Invalid ButtonMode value - raise an error.
        Err.Raise Number:=vbObjectError + 32113, _
            Description:="Invalid ButtonMode value (0 or 1 only)"
    End If
    
End Property

Public Property Get Font() As StdFont
Attribute Font.VB_Description = "The font used to display the control's caption."
Attribute Font.VB_ProcData.VB_Invoke_Property = ";Font"

    Set Font = lblCaption.Font
    
End Property

Public Property Set Font(ByVal newvalue As StdFont)

    'because we are setting the property of an object (Font object)
    'you have to use set instead of let
    Set lblCaption.Font = newvalue
    UserControl.PropertyChanged "Font"
    
End Property

Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "The color of the control's caption. Only used if the ButtonMode property is set to Text Only Mode (0)."
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = ";Appearance"

    ForeColor = lblCaption.ForeColor
    
End Property

Public Property Let ForeColor(ByVal newvalue As OLE_COLOR)
    
    TheFontOldColor = newvalue
    lblCaption.ForeColor = newvalue
    UserControl.PropertyChanged "ForeColor"
    
End Property

Public Property Get SelFontColor() As OLE_COLOR
    SelFontColor = TheFontSelColor
    
End Property

Public Property Let SelFontColor(ByVal NewColor As OLE_COLOR)
    TheFontSelColor = NewColor
    UserControl.PropertyChanged "FontSelColor"
    
End Property
Public Property Get Picture() As StdPicture
Attribute Picture.VB_Description = "The image displayed when the control is in an unselected state. Only used if the ButtonMode property is set to ImageMode (1)."
Attribute Picture.VB_ProcData.VB_Invoke_Property = ";Appearance"

    Set Picture = UserControl.Picture
    
End Property

Public Property Set Picture(ByVal newvalue As StdPicture)

    ' First, change UserControl's Picture property to
    ' display the image selected.
    Set UserControl.Picture = newvalue
    
    ' Then store the new image in a "holding"
    ' picture object.
    Set ThePicture = newvalue
    
    ' If Picture's image is Nothing, set the ButtonMode
    ' property back to Text Only Mode (0). If Picture
    ' does contain an image, set the ButtonMode
    ' property to Image Mode (1).
    If newvalue Is Nothing Then
        ButtonMode = [Text Only Mode]
    Else
        ButtonMode = [Image Only Mode]
    End If
    
    UserControl.PropertyChanged "Picture"
    
End Property

Public Property Get SelBackColor() As OLE_COLOR
Attribute SelBackColor.VB_Description = "The background color used to indicate that the control is in a selected state. Only used if ButtonMode property is set to Text Only Mode (0)."
Attribute SelBackColor.VB_ProcData.VB_Invoke_Property = ";Appearance"

    ' The control's SelColor property is stored in a
    ' "holding" variable, molcSelColor.
    SelBackColor = TheSelColor
    
End Property

Public Property Let SelBackColor(ByVal newvalue As OLE_COLOR)

    ' Store SelColor's new value in a "holding"
    ' variable, molcSelColor.
    TheSelColor = newvalue
    UserControl.PropertyChanged "SelColor"
    
End Property

Public Property Get SelPicture() As StdPicture
Attribute SelPicture.VB_Description = "The image displayed when the control is in a selected state. Only used if the ButtonMode property is set to ImageMode (1)."
Attribute SelPicture.VB_ProcData.VB_Invoke_Property = ";Appearance"
  
  Set SelPicture = TheSelPicture
    
End Property

Public Property Set SelPicture(ByVal newvalue As StdPicture)

    Set TheSelPicture = newvalue
    UserControl.PropertyChanged "SelPicture"
    
End Property

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_ProcData.VB_Invoke_Property = ";Behavior"
Attribute Enabled.VB_UserMemId = -514

    Enabled = UserControl.Enabled
    
End Property

Public Property Let Enabled(ByVal newvalue As Boolean)

    UserControl.Enabled = newvalue
    UserControl.PropertyChanged "Enabled"
    
End Property

Public Sub Refresh()

    UserControl.Refresh
    
End Sub


Public Sub NewBorderStyle()
  
    Select Case TheBorder
    
        Case 0
            Line1.Visible = False
            Line2.Visible = False
            Line3.Visible = False
            Line4.Visible = False
            
        Case 1
            Line1.Visible = True
            Line2.Visible = True
            Line3.Visible = True
            Line4.Visible = True

            Line1.BorderWidth = 2
            Line1.BorderColor = TheBorderShadow
            Line1.X1 = UserControl.ScaleLeft
            Line1.X2 = UserControl.Width

            Line1.Y1 = UserControl.ScaleTop
            Line1.Y2 = UserControl.ScaleTop

            Line2.BorderWidth = 2
            Line2.BorderColor = TheBorderShadow
             Line2.X1 = UserControl.ScaleLeft
            Line2.X2 = UserControl.ScaleLeft
            Line2.Y1 = UserControl.ScaleTop
            Line2.Y2 = UserControl.ScaleHeight
            
            Line3.BorderColor = TheBorderHighLight
            Line3.BorderWidth = 2
            Line3.X1 = UserControl.ScaleLeft + 15
            Line3.X2 = UserControl.ScaleWidth
            Line3.Y1 = UserControl.ScaleHeight - 10
            Line3.Y2 = UserControl.ScaleHeight - 10

            Line4.BorderColor = TheBorderHighLight
            Line4.BorderWidth = 2
            Line4.X1 = UserControl.ScaleWidth - 10
            Line4.X2 = UserControl.ScaleWidth - 10
            Line4.Y1 = UserControl.ScaleTop + 10
            Line4.Y2 = UserControl.ScaleHeight
    
        Case 2
            Line1.Visible = True
            Line2.Visible = True
            Line3.Visible = True
            Line4.Visible = True
            
            Line1.BorderWidth = 2
            Line1.BorderColor = TheBorderHighLight
            Line1.X1 = UserControl.ScaleLeft
            Line1.X2 = UserControl.Width
            
            Line1.Y1 = UserControl.ScaleTop
            Line1.Y2 = UserControl.ScaleTop
            
            Line2.BorderWidth = 2
            Line2.BorderColor = TheBorderHighLight
            Line2.X1 = UserControl.ScaleLeft
            Line2.X2 = UserControl.ScaleLeft
            Line2.Y1 = UserControl.ScaleTop
            Line2.Y2 = UserControl.ScaleHeight
            
            Line3.BorderColor = TheBorderShadow
            Line3.BorderWidth = 2
            Line3.X1 = UserControl.ScaleLeft + 30
            Line3.X2 = UserControl.ScaleWidth
            Line3.Y1 = UserControl.ScaleHeight - 10
            Line3.Y2 = UserControl.ScaleHeight - 10
            
            Line4.BorderColor = TheBorderShadow
            Line4.BorderWidth = 2
            Line4.X1 = UserControl.ScaleWidth - 10
            Line4.X2 = UserControl.ScaleWidth - 10
            Line4.Y1 = UserControl.ScaleTop + 30
            Line4.Y2 = UserControl.ScaleHeight
    End Select

End Sub

Private Sub lblCaption_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub lblCaption_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub lblCaption_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

